#include "touch.h"

str_sensor sensor[SENSOR_NUM];
extern unsigned char sensor_timer_up_flag ;

///---subject to Change because of HW configuration
const unsigned int const_threshold_array[SENSOR_NUM] = { 600, 600, 600, 600};
const unsigned char sensor_name[SENSOR_NUM] = { SENSOR1, SENSOR2, SENSOR3,SENSOR4 };
const unsigned char volatile * const_sensor_dir_reg[SENSOR_NUM] = { &P4DIR,&P4DIR, &P4DIR, &P4DIR};
const unsigned char volatile * const_sensor_Pxsel_reg[SENSOR_NUM] = { &P4SEL,&P4SEL, &P4SEL, &P4SEL};
const unsigned char volatile * const_sensor_Pxsel2_reg[SENSOR_NUM] = { &P4SEL2,&P4SEL2, &P4SEL2, &P4SEL2};

///---subject to Change because of HW configuration

unsigned press_number = 0;
unsigned int WheelPosition=0;
unsigned int LastPosition=0;

unsigned int sensor_scan(unsigned char sensor_no) //sensor_no={0,1,SENSOR_NUM-1}
{
	unsigned int i,j = 0;
	for (i = 0; i < SENSOR_NUM; i++) {
		*(sensor[i].inputPortDirectionRegister) &= ~sensor_name[i];
	}

	*(sensor[sensor_no].inputPxselRegister) &= ~sensor_name[sensor_no];
	*(sensor[sensor_no].inputPxsel2Register) |= sensor_name[sensor_no];

	TA1CTL = TASSEL_3 + MC_2; // TACLK, cont mode
	TA1CCTL1 = CM_3 + CCIS_2 + CAP; // Pos&Neg,GND,Cap
	TA1CTL |= TACLR;
        
        WDTCTL = WDT_MDLY_32 + WDTIE;        
        __bis_SR_register(LPM0_bits+GIE);   // Wait for WDT interrupt
	WDTCTL = WDTPW + WDTHOLD;           // Stop watchdog timer    
        sensor_timer_up_flag = 0;    
        
        j= TA1R;

	*(sensor[sensor_no].inputPxsel2Register) &= ~sensor_name[sensor_no];
        TA1CTL = 0;
	return (j);
}

void data_init(void) {
	unsigned char i, j = 0;

	for (i = 0; i < SENSOR_NUM; i++) {
		sensor[i].inputPortDirectionRegister =
				(unsigned char *) const_sensor_dir_reg[i];
		sensor[i].inputPxselRegister =
				(unsigned char *) const_sensor_Pxsel_reg[i];
		sensor[i].inputPxsel2Register =
				(unsigned char *) const_sensor_Pxsel2_reg[i];
		sensor[i].baseline = 0;
		sensor[i].measure_cnt = 0;
		sensor[i].delta_cnt = 0;
		sensor[i].threshold = const_threshold_array[i];
	}

	for (j = 0; j < 16; j++) {
		for (i = 0; i < SENSOR_NUM; i++) {
			sensor[i].baseline += (sensor_scan(i) >> 4); //baseline init,sampling 16 times
		}
	}

	for (i = 0; i < SENSOR_NUM; i++) {
		sensor[i].measure_cnt = sensor[i].baseline; //measure_cnt init to baseline value
	}

}

// IIR filter
unsigned int filter(unsigned char sensor_no, unsigned int measure_raw,
		unsigned char factor) //low pass filter
{
	unsigned long temp = 0;

	temp = sensor[sensor_no].measure_cnt << factor;
	temp = temp - sensor[sensor_no].measure_cnt;
	temp = temp + measure_raw;
	temp >>= factor;
	return (temp);
}

void low_power_period(unsigned char LowPowerPeriod_mS) {
	BCSCTL3 |= LFXT1S_2; // LFXT1 = VLO
	TA0CCR0 = LowPowerPeriod_mS << 3;
	TA0CTL = TASSEL_1 + MC_1 + TACLR; // ACLK, upmode, interrupt
	TA0CCTL0 = CCIE;
	WDTCTL = WDT_ADLY_1000;
	__bis_SR_register(LPM3_bits+GIE);
}

